#include "Camera.h"

Camera::Camera(void) {
	follow = NULL;
	mode = FREE;

	light.x = 1.0f;
	light.y = 50.0f;
	light.z = 0.0f;

	light.dx = 0.0f;
	light.dy = 0.0f;
	light.dz = 0.0f;
}

Camera::~Camera(void)
{
}

float f = 0.0f;

void Camera::transform(void) {
	switch (mode) {
	case FIRST_PERSON:
		x = follow->x;
		y = follow->y;
		z = follow->z;
		yaw = follow->yaw;
	case FREE:
		glRotatef(-pitch, 1.0f, 0.0f, 0.0f);
		glRotatef(-yaw, 0.0f, 1.0f, 0.0f);
		glRotatef(-roll, 0.0f, 0.0f, 1.0f);

		glTranslatef(-x, -y, -z);
		break;
	case THIRD_PERSON:
		x = followDist * cos((follow->yaw + 270.0f) * PIOVER180) + follow->x;
		z = followDist* sin((follow->yaw - 270.0f) * PIOVER180) + follow->z;
		gluLookAt(x,y,z,follow->x,follow->y,follow->z,0.0,1.0,0.0);
	}

	GLfloat lightPos[4] = {light.x, light.y, light.z, 0.0f};
	glLightfv(GL_LIGHT0, GL_POSITION, lightPos);

}


void Camera::firstPerson(const Entity& ent) {
	follow = &ent;
	followDist = 0.0f;
	mode = FIRST_PERSON;
}

void Camera::thirdPerson(const Entity& ent, float distance) {
	follow = &ent;
	followDist = distance;
	mode = THIRD_PERSON;
}

void Camera::freeCamera() {
	this->follow = NULL;
	mode = FREE;
}
