#pragma once
#include "Entity.h"
#include "stdafx.h"

enum CameraMode {
	FREE,
	THIRD_PERSON,
	FIRST_PERSON
};

struct CameraLight {
	GLfloat x, y, z;
	GLfloat dx, dy, dz;
};

class Camera: public Entity {

public:
	const Entity* follow;
	float followDist;

	CameraMode mode;
	Camera(void);
	~Camera(void);

	CameraLight light;

	void transform(void);

	void freeCamera();
	void firstPerson(const Entity& ent);
	void thirdPerson(const Entity& ent, float dist);
};

