#pragma once
#include "stdafx.h"
#include "Entity.h"
#include "TextureManager.h"
#include "list"

extern TextureManager textureManager;

enum SurfEffect {
	FADE_IN, FADE_OUT, IDLE
};

struct SurfAnimation {
	SurfEffect effect;
	unsigned int duration;
};

class GLSurface: public Entity {
protected:
	virtual void renderEntity();
	GLuint tex;

	std::list<SurfAnimation> qEffects;

	unsigned int lastTicks;
	unsigned int animTime;

	void parseAnim(void);
	void addAnimation(SurfEffect e, unsigned int ms);
	
	
public:
	GLfloat alpha;

	GLSurface(void);
	GLSurface(std::string texture);
	~GLSurface(void);

	bool animating;

	void stopAnimation(void);
	void fadeIn(unsigned int duration);
	void fadeOut(unsigned int duration);
	void idle(unsigned int duration);
};

