#include "IntroWorld.h"

extern Config cfg;

IntroWorld::IntroWorld(std::string startMap) {
	surf = GLSurface("intro.png");
	surf.sy = 0.5f;
	surf.x = 0.5f;
	surf.y = 0.5f;
	gameWorld = startMap;
	nextWorld = NULL;
}


IntroWorld::~IntroWorld(void) {

}

void IntroWorld::setup(void) {
	glMatrixMode(GL_PROJECTION);
	glPushMatrix();
	glLoadIdentity();

	if (cfg.screenW > cfg.screenH) {
		glViewport((cfg.screenW - cfg.screenH) / 2, 0, cfg.screenH, cfg.screenH);
	} else {
		glViewport(0, (cfg.screenH - cfg.screenW) / 2, cfg.screenW, cfg.screenW);
	}
	gluOrtho2D(0.0, 1.0, 0.0, 1.0);
	glScalef(1.0f, -1.0f, 1.0f);
	glTranslatef(0, -1.0f, 0);
	glMatrixMode(GL_MODELVIEW);

	surf.fadeIn(500);
}

void IntroWorld::processLogic(float dt) {
	if (surf.animating == false) {
		if (!nextWorld) {
			nextWorld = new GameWorld(); ((GameWorld*)nextWorld)->loadWorld(gameWorld);
			//nextWorld = new NetServerWorld(); ((NetServerWorld*)nextWorld)->loadWorld(gameWorld);

			//nextWorld = new PlayerSelect(gameWorld);
			surf.fadeOut(500);
		} else {
			running = false;
		}
	}
}

void IntroWorld::renderScene(void) {	
	glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT | GL_STENCIL_BUFFER_BIT);
	
	glLoadIdentity();
	surf.render();
	SDL_GL_SwapBuffers();
}
