#pragma once
#include "stdafx.h"
#include "Entity.h"
#include <vector>

struct Coords3D {
	GLfloat x, y, z;
};

struct Vertex {
	GLfloat x, y, z;        //Vertex
	GLfloat nx, ny, nz;     //Normal
	float s, t;         //Texcoord0
/*	float s1, t1;         //Texcoord1
	float s2, t2;         //Texcoord2 */

	int shared; // The number of times this vertice has been shared
};

struct BoundingBox {
	float minX, maxX;
	float minY, maxY;
	float minZ, maxZ;
};

struct Material {
	float ar, ag, ab; // ambience
	float dr, dg, db; // diffuse
	float sr, sg, sb; // specular
	float shininess;
	float alpha;
	// illumination model
	// - 1 indicates a flat material with no specular highlights
	// - 2 denotes the presence of specular highlights
	int illum;
	GLuint textureVBOID;
};

class Model:
	public Entity {
protected:
	Vertex* vertices;
	int nVertices;
	int nVBOs;
	GLuint* VBOIDs;

	GLuint* indices;
	int nIndices;
	GLuint indicesVBOID;
	
	std::vector<Material> materials;

	virtual void buildVBOs();
public:
	BoundingBox aabb;

	Model(void);
	~Model(void);
	
	virtual void render();
};
