#include "ModelManager.h"

ModelManager::~ModelManager() {
	freeAllModels();
}

Model* ModelManager::getOBJModel(std::string filename) {
	Model* m = pointers[filename];
	if (!m) {
		m = new OBJModel();
		printf("<%s> Loading\n", filename.c_str());
		((OBJModel*)m)->loadFile(filename);
		pointers[filename] = m;
	}
	
	return m;
}

void ModelManager::freeAllModels() {
	for (std::map<std::string, Model*>::iterator it = pointers.begin(); it != pointers.begin(); it++) {
		delete (*it).second;
	}
}