#include "NetCommand.h"


NetCommand::NetCommand(char* data, int size) {
	this->data = data;
	this->dataSize = size;

	char checkSum = calcChecksum(data, size);
	valid = (checkSum != data[size - 1]);
	fromPackage = true;
}

NetCommand::NetCommand(NetCommandID id, const char* args, int size) {
	this->data = new char[size];
	this->data[0] = (char)id;

	memcpy(&data[1], args, size - 2);

	this->dataSize = size;
	this->data[size - 1] = calcChecksum(data, size);
	
	valid = true;
	fromPackage = false;
}

NetCommand::~NetCommand(void) {
	if (!fromPackage) {
		delete[] data;
	}
}

char NetCommand::calcChecksum(char* data, int size) {
	return (char)0;
}

NetCommandID NetCommand::getCommand(void) {
	return (NetCommandID)data[0];
}

char* NetCommand::getData(void) {
	return &data[2];
}

int NetCommand::getDataSize(void) {
	return dataSize;
}

bool NetCommand::isValid(void) {
	return valid;
}