#pragma once
#include "stdafx.h"

enum NetCommandID {
	INVALID = 0x00,
	PING = 0x01,
	PONG = 0x02,
	
	CONNECT = 0x10,
	QUIT = 0x11,

	LEVEL = 0x20,

	CONTROLLER = 0x30	
};

class NetCommand
{
protected:
	char* data;
	int dataSize;
	bool fromPackage;
	bool valid;

	char calcChecksum(char* data, int size);

public:
	NetCommand(char* data, int size);
	NetCommand(NetCommandID id, const char* args, int size);
	~NetCommand(void);

	NetCommandID getCommand(void);
	char* getData(void);
	int getDataSize(void);
	bool isValid(void);
};

