#pragma once
/*
	Simple Network Library from "Networking for Game Programmers"
	http://www.gaffer.org/networking-for-game-programmers
	Author: Glenn Fiedler <gaffer@gaffer.org>

	Adapted by David Serrano	
*/

class NetAddress {
protected:
	unsigned int address;
	unsigned short port;
public:

	NetAddress(void);
	NetAddress(unsigned char a, unsigned char b, unsigned char c, unsigned char d, unsigned short port);
	NetAddress(unsigned int address, unsigned short port);
	unsigned int getAddress(void) const;
	unsigned char getA(void) const;
	unsigned char getB(void) const;
	unsigned char getC(void) const;
	unsigned char getD(void) const;
	unsigned short getPort(void) const;
	bool operator == (const NetAddress & other) const;
	bool operator != (const NetAddress & other) const;
};

class NetSocket {
protected:
    int handler;

public:
	NetSocket(void);
	~NetSocket(void);
	bool open(void);
	bool open(unsigned short port);
	void close(void);
	bool setNonblock(bool nonBlock);
	bool isOpen(void) const;
	bool send(const NetAddress & destination, const void * data, int size);
	int receive(NetAddress & sender, void * data, int size);
};


extern bool net_init(void);
extern void net_cleanup(void);