#include <fstream>
#include "PlayerSelect.h"

extern Config cfg;

PlayerSelect::PlayerSelect(std::string startMap) {
	rotation = 0.0f;
	loadPlayerList();
	setupPlayers();
}


PlayerSelect::~PlayerSelect(void) {

}

void PlayerSelect::setupPlayers(void) {
	int n = players.size();
	int i = 0;
	float angle;

	for (std::vector<Player>::iterator it = players.begin(); it != players.end(); it++) {
		scene.addEntity(*it);
		angle = ((float)i / (float)n) * 360.0f * PIOVER180;
		(*it).setLocation(RADIUS * sinf(angle), 0.0f, RADIUS * cosf(angle));
//		(*it).ry = angle / PIOVER180;
		(*it).yaw = angle / PIOVER180;
		i++;
	}

	scene.camera.setLocation(0.0f, 0.0f, 0.0f);
	scene.skybox.loadSkybox("strand");
}

void PlayerSelect::processInput(float dt) {
	if (control.isDown(turnLeft)) scene.camera.turnRight(-4.0f * dt);
	if (control.isDown(turnRight)) scene.camera.turnRight(4.0f * dt);
}

void PlayerSelect::loadPlayerList(void) {
	std::string list = PLAYER_PATH;
	list += PLAYER_LIST;
	char buff[256];
	std::string sbuff;

	std::ifstream in;
	in.open(list.c_str());

	Player p;

	while (!in.eof()) {
		in.getline(buff, 256);
		sbuff = std::string(buff);
		p.loadPlayer(sbuff);
		players.push_back(p);
	}

	in.close();
}

void PlayerSelect::pollEvent(SDL_Event* e) {
	if ( e->type == SDL_QUIT || 
		(e->type == SDL_KEYDOWN 
			&& e->key.keysym.sym == SDLK_ESCAPE)) {
		running = false;
	}

	control.pollEvent(e);
}

void PlayerSelect::renderScene(void) {
	glMatrixMode(GL_PROJECTION);
	glLoadIdentity();

	glViewport(0, 0, cfg.screenW, cfg.screenH);
	gluPerspective(45.0f, (GLfloat)cfg.screenW / (GLfloat)cfg.screenH, 0.1f, 1000.0f);

	scene.render();
	
	SDL_GL_SwapBuffers();
}
