#include "Scene.h"


Scene::Scene(void) {
}

Scene::~Scene(void) {
}

void Scene::addEntity(Entity& entity) {
	entities.push_back(&entity);
}

void Scene::render(void) {
	// Clear it all
	glMatrixMode(GL_MODELVIEW);
	//glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT | GL_STENCIL_BUFFER_BIT);
	glClear(GL_DEPTH_BUFFER_BIT | GL_STENCIL_BUFFER_BIT);
	glLoadIdentity();
	//Entity::render();
	
	glTranslatef(x, y, z);
	
	glRotatef(pitch, 1.0f, 0.0f, 0.0f);
	glRotatef(yaw, 0.0f, 1.0f, 0.0f);
	glRotatef(roll, 0.0f, 0.0f, 1.0f);
	glScalef(sx, sy, sz);
	
	renderEntity();
}

void Scene::renderEntity(void) {
	// Apply camera transformation to the scene
	camera.transform();

	// Render the skybox
	glPushMatrix();
	skybox.render(camera);
	glPopMatrix();

	// Render entities
	for (std::list<Entity*>::iterator it = entities.begin();
		it != entities.end(); it++) {
		glPushMatrix();

		(*it)->render();

		glPopMatrix();
	}
}
