#include "SoundManager.h"

SoundManager::SoundManager() {
	int frequency = 22050;
	Uint16 format = AUDIO_S16; /* 16-bit stereo */
	int channels = 2;
	int buffer_size = 4096;

	Mix_Init(0);
	Mix_OpenAudio(frequency, format, channels, buffer_size);
}

SoundManager::~SoundManager() {
	clearSounds();
	Mix_CloseAudio();
}

void SoundManager::clearSounds() {
	sounds.clear();
}

Mix_Chunk* SoundManager::loadSound(const std::string& soundPath) {
	Mix_Chunk* music = sounds[soundPath];
	std::string file = SOUND_PATH + soundPath; 

	if (!music) {
		music = Mix_LoadWAV(file.c_str());
		sounds[soundPath] = music;
	}

	return music;
}

int SoundManager::playSound(Mix_Chunk* sound) {
	if (enabled) {
		return Mix_PlayChannel(-1, sound, 0);
	} else {
		return -1;
	}
}
