#include "TextureManager.h"


TextureManager::TextureManager(void) {
}


TextureManager::~TextureManager(void) {
	clearTextures();
}

void TextureManager::clearTextures(void) {
	for (std::map<std::string, GLuint>::iterator it = textures.begin();
		it != textures.begin(); it++) {
		
			glDeleteTextures(1, &(it->second));
	}
}

GLuint TextureManager::loadTexture(const std::string& texture) {
	return loadTexture(texture, false);
}

GLuint TextureManager::loadTexture(const std::string& texture, bool absolute) {
	return loadTexture(texture, absolute, SOIL_FLAG_INVERT_Y);
}

GLuint TextureManager::loadTexture(const std::string& texture, bool absolute, int SOILFlags) {
	GLuint tex = textures[texture];
	std::string path;

	if (!absolute) {
		path = TEXTURE_PATH + texture;
	} else {
		path = texture;
	}

	if (!tex) {
		tex = SOIL_load_OGL_texture(path.c_str(),
					SOIL_LOAD_AUTO, 
					SOIL_CREATE_NEW_ID,
					SOILFlags);

		if (!tex) {
			fprintf(stderr, "<%s> Could not load texture\n", path.c_str());
			return 0;
		}

		textures[texture] = tex;
	}

	return tex;
}
