#pragma once
#include "stdafx.h"

#define DATA_PATH "data/"
#define MODEL_PATH "data/models/"
#define TEXTURE_PATH "data/textures/"
#define TEXTURE_EXT ".png"
#define SHADER_PATH "data/shaders/"
#define MAP_PATH "data/maps/"
#define SKY_PATH "data/sky/"
#define SOUND_PATH "data/sounds/"
#define PLAYER_PATH "data/players/"

#define PLAYER_LIST "players.list"
#define CONFIG_PATH "config.json"

#define START_MAP "raceway.json"

#define SCREEN_W 1280
#define SCREEN_H 600
#define FULLSCREEN false
#define GAME_SPEED 60
#define FPS 60
#define INPUT_LATENCY 0

#define CONTROLLER_KEYS { \
	SDLK_UP, \
	SDLK_DOWN, \
	SDLK_LEFT, \
	SDLK_RIGHT, \
	SDLK_F1, \
	SDLK_r, \
	SDLK_RETURN, \
	SDLK_s, \
	SDLK_w \
}

class Config {
public:
	unsigned int screenW;
	unsigned int screenH;
	unsigned int gameSpeed;
	unsigned int fps;
	bool fullscreen;
	bool skipIntro;
	std::string initialMap;
	Json::Value controls;

	// Debug
	unsigned int minInputLatency;
	unsigned int maxInputLatency;
	unsigned int dropProbability;

	Config(void);
	~Config(void);
	
	void load(void);
	void load(std::string& file);
};