// stdafx.h : include file for standard system include files,
// or project specific include files that are used frequently, but
// are changed infrequently
//

#pragma once

// Platform detection
#define PLATFORM_WINDOWS  1
#define PLATFORM_MAC      2
#define PLATFORM_UNIX     3

#if defined(_WIN32)
#define PLATFORM PLATFORM_WINDOWS
#elif defined(__APPLE__)
#define PLATFORM PLATFORM_MAC
#else
#define PLATFORM PLATFORM_UNIX
#endif

#include <stdio.h>
#include <math.h>
#include <time.h>

#include <limits>
#include <string>

#if PLATFORM == PLATFORM_WINDOWS

#pragma comment(lib, "SDL.lib")
#pragma comment(lib, "SDLmain.lib")
#pragma comment(lib, "opengl32.lib")
#pragma comment(lib, "glu32.lib")
#pragma comment(lib, "glew32.lib")
#pragma comment(lib, "wsock32.lib")

#define WIN32_LEAN_AND_MEAN
#include "targetver.h"
#include <windows.h>
#endif

#if PLATFORM == PLATFORM_MAC
#include <OpenGL/glew.h>	// Header File For The GLew Library
#include <OpenGL/gl.h>	// Header File For The OpenGL32 Library
#include <OpenGL/glu.h>	// Header File For The GLu32 Library
#else
#include <GL/glew.h>	// Header File For The GLew Library
#include <GL/gl.h>	// Header File For The OpenGL32 Library
#include <GL/glu.h>	// Header File For The GLu32 Library
#endif

#include "SDL/SDL.h"
#include "SDL/SDL_thread.h"

#include "soil/SOIL.h"
#include "json/json.h"

#include "utils.h"
#include "config.h"
